<?php

class DDBUILDER_Grid_Item_Module extends ET_Builder_Module {

	public $slug       = 'dondivi_grid_item';
	public $vb_support = 'on';
	

	public function init() {
		$this->name = esc_html__( 'Grid Item', 'dd_builder' );
		$this->type = 'child';
		$this->child_title_var = 'admin_title';

		$this->main_css_element = '%%order_class%%';

		$this->settings_modal_toggles = array(
			'general'   => array(
				'toggles' => array(
					'main_content'	=> esc_html__( 'Grid Item', 'dd_builder' ),
				),
			),
			'advanced'   => array(
				'toggles' => array(
					'grid_item' 	=> esc_html__( 'Grid Item', 'dd_builder' ),
					'icon' 			=> esc_html__( 'Image & Icon', 'et_builder' ),
					'title' 		=> et_builder_i18n( 'Title' ),
					'body'   		=> array(
						'title'             => et_builder_i18n( 'Body' ),
						'tabbed_subtoggles' => true,
						'bb_icons_support'  => true,
						'sub_toggles'       => array(
							'p'     => array(
								'name' => 'P',
								'icon' => 'text-left',
							),
							'a'     => array(
								'name' => 'A',
								'icon' => 'text-link',
							),
							'ul'    => array(
								'name' => 'UL',
								'icon' => 'list',
							),
							'ol'    => array(
								'name' => 'OL',
								'icon' => 'numbered-list',
							),
							'quote' => array(
								'name' => 'QUOTE',
								'icon' => 'text-quote',
							),
						),
					),
					'effects'       => sprintf( '%1$s %2$s', esc_html__( 'Image & Icon', 'et_builder' ), esc_html__( 'Animation', 'et_builder' ) ),
				),
			),
		);

		$this->advanced_fields = array(
			'background'     => array(
				'css' => array(
					'important' => 'all',
				),
			),
			'borders' => array(
				'default' => array (
					'css' => array(
						'main' => array(
							'border_radii' 	=> "%%parent_class%% {$this->main_css_element}.dondivi_grid_item",	
							'border_styles'	=> "%%parent_class%% {$this->main_css_element}.dondivi_grid_item",
						),												
					),				
				),
			),
			'button'         => array(
				'button' => array(
					'label'          => et_builder_i18n( 'Button' ),
					'css'            => array(
						'main'         => "{$this->main_css_element} .ddb-grid-item-button",
						'alignment'    => "{$this->main_css_element} .et_pb_button_module_wrapper",
					),
					'use_alignment'  => true,
					'box_shadow'     => array(
						'css' => array(
							'main' => '%%order_class%% .ddb-grid-item-button',
						),
					),
					'toggle_slug' 		=> 'button', 
				),
			),
			'fonts'          => array(
				'title' => array(
					'label'        	=> et_builder_i18n( 'Title' ),
					'css'          	=> array(
						'main'  => "{$this->main_css_element} .ddb-custom-grid-item .ddb-grid-item-title",
						'hover' => "{$this->main_css_element}:hover .ddb-custom-grid-item .ddb-grid-item-title",
					),
					'header_level' 	=> array(
						'default' => 'h4',
					),
					'text_shadow' 	=> array( 'show_if' => array( 'item_content' => 'custom' ) ),
					'toggle_slug' 	=> 'title', 
				),
				'body'   => array(
					'label'         => et_builder_i18n( 'Body' ),
					'css'           => array(
						'main' 		=> "{$this->main_css_element} .ddb-custom-grid-item .ddb-grid-item-body",
					),
					'text_shadow' 	=> array( 'show_if' => array( 'item_content' => 'custom' ) ),
					'toggle_slug' 	=> 'body',
					'sub_toggle' 	=> 'p', 
				),
				'body_link'     => array(
					'label'       	=> et_builder_i18n( 'Link' ),
					'css'         	=> array(
						'main'  => "{$this->main_css_element} .ddb-custom-grid-item a",
					),
					'text_shadow' 	=> array( 'show_if' => array( 'item_content' => 'custom' ) ),
					'toggle_slug' 	=> 'body',
					'sub_toggle'  	=> 'a',
				),
				'body_ul'       => array(
					'label'       	=> esc_html__( 'Unordered List', 'et_builder' ),
					'css'         	=> array(
						'main'        => "{$this->main_css_element} .ddb-custom-grid-item ul li",
						'item_indent' => "{$this->main_css_element} .ddb-custom-grid-item ul",
					),
					'text_shadow' 	=> array( 'show_if' => array( 'item_content' => 'custom' ) ),
					'toggle_slug' 	=> 'body',
					'sub_toggle'  	=> 'ul',
				),
				'body_ol'       => array(
					'label'       	=> esc_html__( 'Ordered List', 'et_builder' ),
					'css'         	=> array(
						'main'        => "{$this->main_css_element} .ddb-custom-grid-item ol li",
						'item_indent' => "{$this->main_css_element} .ddb-custom-grid-item ol",
					),
					'text_shadow' 	=> array( 'show_if' => array( 'item_content' => 'custom' ) ),
					'toggle_slug' 	=> 'body',
					'sub_toggle'  	=> 'ol',
				),
				'body_quote'    => array(
					'label'       	=> esc_html__( 'Blockquote', 'et_builder' ),
					'css'         	=> array(
						'main'  => "{$this->main_css_element} .ddb-custom-grid-item blockquote",
					),
					'text_shadow' 	=> array( 'show_if' => array( 'item_content' => 'custom' ) ),
					'toggle_slug' 	=> 'body',
					'sub_toggle'  	=> 'quote',
				),
			),
			'image_icon'     => array(
				'image_icon' => array(
					'label'           	=> et_builder_i18n( 'Image/Icon' ),
					'css'             	=> array(
						'main'    => '%%order_class%% .ddb-grid-item-image-icon'
					),
					'toggle_slug'     	=> 'icon',
				),
			),
			'margin_padding'  => array(
				'css' => array(
					'important' => 'all',
				),
			),
			'text' => false,
		);

		$this->custom_css_fields = array(
			'icon_css' => array(
				'label'    	=>  et_builder_i18n( 'Image/Icon' ),
				'selector' 	=> '%%order_class%% .ddb-grid-item-image-icon',
				'show_if'  	=> array( 'item_content' => 'custom' ),
			),
			'title_css' => array(
				'label'    	=> et_builder_i18n( 'Title' ),
				'selector' 	=> '%%order_class%% .ddb-custom-grid-item .ddb-grid-item-title',
				'show_if' 	=> array('item_content' => 'custom'),
			),
            'body_css' => array(
				'label'    	=> et_builder_i18n( 'Body' ),
				'selector' 	=> '%%order_class%% .ddb-custom-grid-item .ddb-grid-item-body',
				'show_if' 	=> array('item_content' => 'custom'),
			),
		);
	}
    
	public function get_fields() {
		$helper = new DonDiviBuilderFields();
		$fields = array(
			'item_content' 	=> array(
				'label'        	=> et_builder_i18n( 'Content' ),
				'type'         	=> 'select',
				'options'       => array(
					'custom' 	=> esc_html__( 'Custom', 'et_builder' ),
					'layout'  	=> esc_html__( 'Divi Layout', 'dd_builder' ),
				),
				'default'		=> 'custom',
				'toggle_slug'   => 'main_content',
			),
			'layout_id' => array(
				'label'           	=> esc_html__( 'Divi Layout', 'dd_builder' ),
				'description'     	=> esc_html__( 'Here you can choose the Divi Library saved layout.', 'dd_builder' ),
				'type'            	=> 'select',
				'options'			=> $helper->get_all_layouts(),
				'searchable'       	=> true,
				'displayRecent'    	=> false,
				'show_if'			=> array('item_content' => 'layout'),
				'toggle_slug'     	=> 'main_content',				
			),
			'__layout'	=> array(
				'type'                => 'computed',
				'computed_callback'   => array( 'DonDiviBuilderHelper', 'render_divi_layout' ),
				'computed_depends_on' => array(
					'layout_id',
				),
				'computed_minimum' => array(
					'layout_id',
				),
			),
			'item_position'	=> array(
				'label' 		=> et_builder_i18n( 'Position '),
				'type'			=> 'dondivi_grid_position',
				'mobile_options'	=> true,
				'tab_slug'     	=> 'advanced',
				'toggle_slug'	=> 'grid_item'
			),
			'admin_title'	=> array(
				'label'       	=> et_builder_i18n( 'Admin Label' ),
				'description' 	=> esc_html__( 'This will change the label of the grid item in the builder for easy identification.', 'dd_builder' ),
				'type'        	=> 'text',
				'default'		=> esc_html__( 'Grid Item', 'dd_builder' ),
				'toggle_slug' 	=> 'admin_label',
			),
		);
		$fields['module_class'] = $helper->get_custom_class_field();
		$cc_settings = array(
			'content_slug' 	=> 'main_content',
			'link_slug'		=> 'link_options',
			'advanced_slug'	=> 'main_content',
			'icon'			=> true,
			'icon_slug'		=> 'icon',
			'button'		=> true,
			'show_if_not' 	=> array('item_content' => 'layout'),
		); 
		return array_merge(
			$fields, 
			$helper->get_font_fields( 'body_ul', 'body_ol', 'body_quote', 'body'),
			$helper->get_custom_content_fields($cc_settings), 
			$helper->get_effect_fields( 'effects', array( 'item_content' => 'custom', 'cc_icon_image' => array( 'icon', 'image')), 'none', 'none', '1000ms', true )
		);
	}

	public function render( $attrs, $content, $render_slug ) {
		$helper 	= DonDiviBuilderHelper::get();
		$multi_view	= et_pb_multi_view_options( $this );

		if ( $this->props['item_content'] !== 'layout' && $this->props['cc_icon_image'] !== 'none') {
			wp_enqueue_script( 'ddb-grid' );
		}
		
		$position_values = et_pb_responsive_options()-> get_property_values($this->props, 'item_position', $this->props['item_position'], true);
		foreach ( et_pb_responsive_options()->get_modes() as $device ) {
			$position = json_decode(html_entity_decode($position_values[$device]), true);
			if ($position) {
				$helper->set_style( 
					$render_slug, 
					'%%order_class%%', 
					sprintf('grid-area: %1$s/%2$s/%3$s/%4$s;', $position['startRow'], $position['startCol'], $position['endRow'], $position['endCol']),
					substr($device, 0, 1) 
				);
			}
		}

		$grid_content = '';
		if ($this->props['item_content'] !== 'layout') {
			$grid_content = sprintf('<div class="ddb-custom-grid-item ddb-f">%s</div>', 
				$helper->render_custom_content( $this, array( 'slug' => 'grid-item', 'waypoints' => true ) )
			);
		} else {
			$grid_content = $helper->render_divi_layout( array('internal' => false, 'layout_id' => $this->props['layout_id']) );
		} 
		return sprintf( '<div class="ddb-grid-content">%s</div>', $grid_content );
	}

	public function multi_view_filter_value( $raw_value, $args ) {

		$name = isset( $args['name'] ) ? $args['name'] : '';

		if ( $raw_value && ('cc_icon' === $name ) ) {
			return et_pb_get_extended_font_icon_value( $raw_value, true );
		}
		return $raw_value;
	}
}

new DDBUILDER_Grid_Item_Module;
