<?php

class DDBUILDER_Hotspot_Item_Module extends ET_Builder_Module {

    public $slug       = 'dondivi_hotspot';
    public $vb_support = 'on';

    public function init() {
        $this->name 		= esc_html__( 'Hotspot', 'dd_builder' );
        $this->type = 'child';
        $this->child_title_var = 'title';

		$this->main_css_element = '%%order_class%%';

        $this->settings_modal_toggles = array(
            'general'    => array(
                'toggles' => array(
                    'main_content'  => esc_html__( 'Hotspot', 'dd_builder' ),
                    'content' 		=> esc_html__( 'Content', 'et_builder' ),
                ),
            ),
            'advanced'    => array(
                'toggles' => array(
                    'hotspot' 	=>  esc_html__( 'Hotspot', 'dd_builder' ),
					'item_text'	=> sprintf( '%1$s %2$s', esc_html__( 'Hotspot', 'dd_builder' ), et_builder_i18n( 'Text' ) ),
					'icon' 		=> sprintf( '%1$s %2$s', esc_html__( 'Hotspot', 'dd_builder' ), esc_html__( 'Image & Icon', 'et_builder' ) ),
                    'link' 		=> et_builder_i18n( 'Content' ),
					'link_icon'	=> sprintf( '%1$s %2$s', et_builder_i18n( 'Content' ), esc_html__( 'Image & Icon', 'et_builder' ) ),
					'title' 	=> sprintf( '%1$s %2$s', et_builder_i18n( 'Content' ), et_builder_i18n( 'Title' ) ),
					'body'   => array(
						'title'             => sprintf( '%1$s %2$s', et_builder_i18n( 'Content' ), et_builder_i18n( 'Body' ) ),
						'tabbed_subtoggles' => true,
						'bb_icons_support'  => true,
						'sub_toggles'       => array(
							'p'     => array(
								'name' => 'P',
								'icon' => 'text-left',
							),
							'a'     => array(
								'name' => 'A',
								'icon' => 'text-link',
							),
							'ul'    => array(
								'name' => 'UL',
								'icon' => 'list',
							),
							'ol'    => array(
								'name' => 'OL',
								'icon' => 'numbered-list',
							),
							'quote' => array(
								'name' => 'QUOTE',
								'icon' => 'text-quote',
							),
						),
					),
					'button'	=> sprintf( '%1$s %2$s', et_builder_i18n( 'Content' ), et_builder_i18n( 'Button' ) ),
					'effects'	=> sprintf( '%1$s %2$s', et_builder_i18n( 'Content' ), esc_html__( 'Animation', 'et_builder' ) ),
                ),
            ),
        );
		$this->advanced_fields = array(
			'background'	=> false,
            'borders' => array(
				'default' => array(
					'label_prefix' => esc_html__( 'Hotspot', 'dd_builder' ),
					'css'      => array(
						'main' => array(
							'border_radii'  => '%%order_class%% .ddb-hotspot, %%order_class%% .ddb-pulse',
							'border_styles' => "%%order_class%% .ddb-hotspot",
						),
					),
					'defaults' => array(
						'border_radii' => 'on|50px|50px|50px|50px',
					),
					'toggle_slug' 	=> 'hotspot', 
				),
				'tooltip' => array (
					'label_prefix'    => esc_html__( 'Tooltip', 'et_builder' ),
					'css' => array(
						'main' => array(
							'border_radii' =>  "{$this->main_css_element} .ddb-custom-hotspot",
							'border_styles' => "{$this->main_css_element} .ddb-custom-hotspot",
						),													
					),	
					'toggle_slug' 		=> 'link', 
					'depends_on'    	=> array( 'link_type' ),
					'depends_show_if' 	=> 'tooltip',				
				),
				'popup' => array (
					'label_prefix'    => esc_html__( 'Popup', 'dd_builder' ),
					'css' => array(
						'main' => array(
							'border_radii' =>  "{$this->main_css_element}_popup .ddb-custom-hotspot",
							'border_styles' => "{$this->main_css_element}_popup .ddb-custom-hotspot",
						),													
					),	
					'toggle_slug' 		=> 'link', 
					'depends_on'    	=> array( 'link_type' ),
					'depends_show_if' 	=> 'popup_c',				
				),
			),
			'box_shadow' => array(
				'default' => array(
					'label' => esc_html__( 'Hotspot', 'dd_builder' ),
					'css'      => array(
						'main' => '%%order_class%% .ddb-hotspot',
					),
				),
				'tooltip' => array (
					'label'	=>	esc_html__( 'Tooltip', 'et_builder' ),
					'css' 	=> array(
						'main' => "{$this->main_css_element} .ddb-custom-hotspot" 														
					),
					'depends_on'    	=> array( 'link_type' ),
					'depends_show_if' 	=> 'tooltip',						
				),
				'popup' => array (
					'label'	=>	esc_html__( 'Popup', 'dd_builder' ),
					'css' 	=> array(
						'main' => "{$this->main_css_element}_popup .ddb-custom-hotspot" 														
					),
					'depends_on'    	=> array( 'link_type' ),
					'depends_show_if' 	=> 'popup_c',							
				),
			),
			'button'         => array(
				'button' => array(
					'label'        	=> et_builder_i18n( 'Button' ),
					'css'          	=> array(
						'main'         => "{$this->main_css_element} .ddb-hotspot-button, {$this->main_css_element}_popup_inner .ddb-hotspot-button",
						'alignment'    => "{$this->main_css_element} .et_pb_button_module_wrapper, {$this->main_css_element}_popup .et_pb_button_module_wrapper",
					),
					'use_alignment' => true,
					'box_shadow'    => array(
						'css' => array( 
							'main' => '%%order_class%% .ddb-hotspot-button, %%order_class%%_popup_inner .ddb-hotspot-button',
						),
					),
					'toggle_slug' 	=> 'button', 
				),
			),
			'fonts'          => array(
				'hotspot' => array(
					'label'        => esc_html__( 'Hotspot', 'dd_builder' ),
					'css'          => array(
						'main'  => "{$this->main_css_element} .ddb-hotspot-text",
						'hover'	=> "{$this->main_css_element} .ddb-hotspot:hover > .ddb-hotspot-text, {$this->main_css_element} .ddb-hotspot.active > .ddb-hotspot-text",
					),
					'font_size'       => array(
						'default' => absint( et_get_option( 'body_font_size', '14' ) ) . 'px',
					),
					'text_shadow' => array(
						'show_if' => array( 'item_content' => 'text' )
					),
					'hide_line_height' 	=> true,
					'hide_text_align' 	=> true,
					'depends_show_if'   => 'text',
					'toggle_slug'     	=> 'item_text',
				),
				'title' => array(
					'label'        	=> et_builder_i18n( 'Title' ),
					'css'          	=> array(
						'main'  => "{$this->main_css_element} .ddb-hotspot-title, {$this->main_css_element}_popup .ddb-hotspot-title",
					),
					'header_level' => array(
						'default' => 'h4',
					),
					'text_shadow' 	=> array( 'show_if' => array( 'link_type' => array( 'tooltip', 'popup_c' ) ) ),
					'toggle_slug'  	=> 'title',
				),
				'body'   => array(
					'label'         => et_builder_i18n( 'Body' ),
					'css'           => array(
						'main' => "{$this->main_css_element} .ddb-hotspot-body, {$this->main_css_element}_popup .ddb-hotspot-body",
					),
					'font_size' 	=> array( 
						'default' => absint( et_get_option( 'body_font_size', '14' ) ) . 'px',
					),
					'text_shadow' 	=> array( 'show_if' => array( 'link_type' => array( 'tooltip', 'popup_c' ) ) ),
					'toggle_slug' 	=> 'body',
					'sub_toggle' 	=> 'p', 
				),
				'body_link'     => array(
					'label'       	=> et_builder_i18n( 'Link' ),
					'css'         	=> array(
						'main'  => "{$this->main_css_element} .ddb-hotspot-body a, {$this->main_css_element}_popup .ddb-hotspot-body a",
					),
					'text_shadow' 	=> array( 'show_if' => array( 'link_type' => array( 'tooltip', 'popup_c' ) ) ),
					'toggle_slug' 	=> 'body',
					'sub_toggle'  	=> 'a',
				),
				'body_ul'       => array(
					'label'       	=> esc_html__( 'Unordered List', 'et_builder' ),
					'css'         	=> array(
						'main'        => "{$this->main_css_element} .ddb-hotspot-body ul li, {$this->main_css_element}_popup .ddb-hotspot-body ul li",
						'item_indent' => "{$this->main_css_element} .ddb-hotspot-body ul, {$this->main_css_element}_popup .ddb-hotspot-body ul",
					),
					'text_shadow' 	=> array( 'show_if' => array( 'link_type' => array( 'tooltip', 'popup_c' ) ) ),
					'toggle_slug' 	=> 'body',
					'sub_toggle'  	=> 'ul',
				),
				'body_ol'       => array(
					'label'       	=> esc_html__( 'Ordered List', 'et_builder' ),
					'css'         	=> array(
						'main'        => "{$this->main_css_element} .ddb-hotspot-body ol li, {$this->main_css_element}_popup .ddb-hotspot-body ol li",
						'item_indent' => "{$this->main_css_element} .ddb-hotspot-body ol, {$this->main_css_element}_popup .ddb-hotspot-body ol",
					),
					'text_shadow' 	=> array( 'show_if' => array( 'link_type' => array( 'tooltip', 'popup_c' ) ) ),
					'toggle_slug' 	=> 'body',
					'sub_toggle'  	=> 'ol',
				),
				'body_quote'    => array(
					'label'       	=> esc_html__( 'Blockquote', 'et_builder' ),
					'css'         	=> array(
						'main'  => "{$this->main_css_element} .ddb-hotspot-body blockquote, {$this->main_css_element}_popup .ddb-hotspot-body blockquote",
					),
					'text_shadow' 	=> array( 'show_if' => array( 'link_type' => array( 'tooltip', 'popup_c' ) ) ),
					'toggle_slug' 	=> 'body',
					'sub_toggle'  	=> 'quote',
				),
			),
			'image_icon'     => array( 
				'image_icon' => array(
					'label'           => et_builder_i18n( 'Image/Icon' ),
					'css'             => array(
						'main' => '%%order_class%% .ddb-hotspot-image-icon, %%order_class%%_popup .ddb-hotspot-image-icon',
					),
					'toggle_slug'     => 'link_icon',
				),				
				'hotspot' => array( 
					'label'           => esc_html__( 'Hotspot', 'dd_builder' ),
					'css'             => array(
						'main' => '%%order_class%% .ddb-hotspot', 
					),			
					'margin_padding'  => array(
						'use_margin' 		=> false,
					),
					'toggle_slug'     	=> 'hotspot',
				),
				'tooltip' => array( 
					'label'           => esc_html__( 'Tooltip', 'et_builder' ),
					'css'             => array(
						'main' => '%%order_class%% .ddb-custom-hotspot', 
					),			
					'margin_padding'  => array(
						'use_margin' 		=> false,
					),
					'toggle_slug'     	=> 'link',
				),
				'popup' => array( 
					'label'           => esc_html__( 'Popup', 'dd_builder' ),
					'css'             => array(
						'main' => '%%order_class%%_popup .ddb-popup > div',
					),			
					'margin_padding'  => array(
						'use_margin' 		=> false,
					),
					'toggle_slug'     	=> 'link',
				),
			),
            'link_options' 	=> false,
			'max_width'   	=> false,
            'position_fields' => false,	
			'text'          => array(
				'css'                   => array(
					'text_orientation' => "{$this->main_css_element} .ddb-custom-hotspot, {$this->main_css_element}_popup .ddb-custom-hotspot",
				),
				'options'               => array(
					'text_orientation'  => array(
						'default_on_front' => 'left',
						'show_if' => array('link_type' => array('tooltip', 'popup_c')),
						'toggle_slug' => 'link',
					),
				),
			),
			'text_shadow' 	=> array(
				'default' => false,
			),
		);

		$this->custom_css_fields = array(
			'tooltip_css' => array(
				'label'   	=> et_builder_i18n( 'Tooltip' ),
				'selector' 	=> '%%order_class%% .ddb-custom-hotspot',
				'show_if' 	=> array( 'link_type' => 'tooltip'),
			),
			'popup' => array(
				'label'    => et_builder_i18n( 'Content' ),
				'selector' => '%%order_class%%_popup .ddb-popup > div',
				'show_if' => array( 'link_type' => array( 'popup_c', 'popup_l' ) ),
			),	
			'content_icon_css' => array(
				'label'    	=>  sprintf( '%1$s %2$s', et_builder_i18n( 'Content' ), et_builder_i18n( 'Image/Icon' ) ),
				'selector' 	=> '%%order_class%% .ddb-hotspot-image-icon, %%order_class%%_popup .ddb-hotspot-image-icon',
				'show_if'  	=> array( 'link_type' => array( 'popup_c', 'tooltip' ), 'cc_icon_image' => array( 'icon', 'image' ) ),
			),
			'content_title_css' => array(
				'label'    	=>  sprintf( '%1$s %2$s', et_builder_i18n( 'Content' ), et_builder_i18n( 'Title' ) ),
				'selector' 	=> '%%order_class%% .ddb-hotspot-title, %%order_class%%_popup .ddb-hotspot-title',
				'show_if'  	=> array( 'link_type' => array( 'popup_c', 'tooltip' ) ),
			),
			'content_body_css' => array(
				'label'    	=>  sprintf( '%1$s %2$s', et_builder_i18n( 'Content' ), et_builder_i18n( 'Body' ) ),
				'selector' 	=> '%%order_class%% .ddb-hotspot-body, %%order_class%%_popup .ddb-hotspot-body',
				'show_if'  	=> array( 'link_type' => array( 'popup_c', 'tooltip' ) ),
			),
		);
    }

    public function get_fields() {
		$helper = new DonDiviBuilderFields();
        $fields = array(
            'title' => array(
				'label'       		=> et_builder_i18n( 'Title' ),
				'description' 		=> esc_html__( 'Define the Title for this hotspot.', 'dd_builder' ),
				'type'        		=> 'text',
				'default'  			=> esc_html( 'Hotspot' ),				
				'hover'				=> 'tabs',
				'toggle_slug' 		=> 'main_content',
				'dynamic_content' 	=> 'text',	
			),
			'item_content' 	=> array(
				'label' 			=> et_builder_i18n( 'Content' ),
				'type'          	=> 'select',
				'options'       => array(
					'none' 		=> esc_html__( 'None', 'et_builder' ),
					'icon' 		=> esc_html__( 'Icon', 'et_builder' ),
					'image'  	=> esc_html__( 'Image', 'et_builder' ),
					'text'  	=> esc_html__( 'Text', 'et_builder' )
				),
				'affects' 			=> array( 'hotspot_font', 'hotspot_font_size', 'hotspot_letter_spacing', 'hotspot_text_color', 'hotspot_text_shadow' ),
				'default'			=> 'icon',
				'toggle_slug'       => 'main_content',
			),
			'item_font_icon' => array(
				'label'             => esc_html__( 'Icon', 'et_builder' ),
				'type'              => 'select_icon',
				'class'             => array( 'et-pb-font-icon' ),
				'default'			=> '&#x4c;||divi||400',
				'show_if'			=> array( 'item_content' => 'icon' ),
				'hover'				=> 'tabs',
				'mobile_options'	=> true,
				'toggle_slug'       => 'main_content',			
			),
			'item_image' => array(
				'label'             => esc_html__( 'Image', 'et_builder' ),
				'type'              => 'upload',
				'upload_button_text'=> esc_attr__( 'Upload an image', 'et_builder' ),
				'choose_text'       => esc_attr__( 'Choose an Image', 'et_builder' ),
				'update_text'       => esc_attr__( 'Set As Image', 'et_builder' ),
				'show_if'			=> array('item_content' => 'image'),
				'mobile_options'  	=> true,
				'hover'				=> 'tabs',
				'dynamic_content'   => 'image',
				'toggle_slug'       => 'main_content',
			),
            'link_type' => array(
				'label'       		=> esc_html__( 'Link Type', 'dd_builder' ),
				'type'        		=> 'select',
				'options'			=> array(
					'none' 		=> esc_html( 'None' ),
					'url' 		=> esc_html( 'URL' ),
					'tooltip' 	=> esc_html( 'Tooltip' ),
					'popup_c' 	=> esc_html( 'Content Popup', 'dd_builder' ),
                    'popup_l' 	=> esc_html( 'Layout Popup', 'dd_builder' ),
				),
				'default'  			=> 'none',				
				'toggle_slug' 		=> 'content',	
			),
			'divi_layout' => array(
				'label'           	=> esc_html__( 'Layout', 'et_builder' ),
				'description'     	=> esc_html__( 'Here you can choose the Divi Library saved layout.', 'dd_builder' ),
				'type'            	=> 'select',
				'options'			=> $helper->get_all_layouts(),
				'show_if' 			=> array('link_type' => 'popup_l'),
				'searchable'       	=> true,
				'displayRecent'    	=> false,
				'toggle_slug'     	=> 'content',				
			),
			'tooltip_preview' 	=> array(
				'label'            	=> esc_html__( 'Preview in the Builder', 'dd_builder' ),
				'description'		=> esc_html__( 'Toggle this field to temporarily preview the tooltip.', 'dd_builder' ),
				'type'          	=> 'yes_no_button',
				'options'      		=> $helper->get_yes_no_button_options(),
				'default'			=> 'off',
				'show_if' 			=> array( 'link_type' => 'tooltip'),
				'toggle_slug'      	=> 'content',
			),
			'tooltip_hover' => array(
				'label'         => esc_html__( 'Show On Hover', 'dd_builder' ),
				'type'          => 'yes_no_button',
				'options'      	=> $helper->get_yes_no_button_options(),
				'default'		=> 'on',
				'show_if' 		=> array('link_type' => 'tooltip'),
				'toggle_slug'   => 'content',				
			),
			'tooltip_arrow' => array(
				'label'         => esc_html__( 'Show Arrow', 'dd_builder' ),
				'type'          => 'yes_no_button',
				'options'      	=> $helper->get_yes_no_button_options(),
				'default'		=> 'off',
				'show_if' 		=> array('link_type' => 'tooltip'),
				'toggle_slug'   => 'content',				
			),
            'hotspot_top'           => array(
				'label'             => esc_html__( 'Top Position', 'dd_builder' ),
				'type'              => 'range',
				'default'           => '50%',
                'default_unit'      => '%',
				'mobile_options'    => true,
				'tab_slug'          => 'advanced',
				'toggle_slug'       => 'hotspot',
			),
			'hotspot_left'          => array(
				'label'             => esc_html__( 'Left Position', 'dd_builder' ),
				'type'              => 'range',
                'default'           => '50%',
                'default_unit'      => '%',
				'mobile_options'    => true,
				'tab_slug'          => 'advanced',
				'toggle_slug'       => 'hotspot',
			),
			'hotspot_background_color'       => array(
				'label'           	=> esc_html__( 'Background Color', 'et_builder' ),
				'type'            	=> 'color-alpha',
				'default'			=> et_builder_accent_color(),
				'mobile_options'  	=> true,
				'sticky'          	=> true,
				'hover'				=> 'tabs',
				'tab_slug'        	=> 'advanced',
				'toggle_slug'     	=> 'hotspot',
			),
			'enable_pulse' => array(
				'label'           	=> esc_html__( 'Enable Pulse Effect', 'dd_builder' ),
				'type'            	=> 'yes_no_button',
				'options'          	=> $helper->get_yes_no_button_options(),
				'default' 	        => 'off',
				'affects' 			=> array( 'pulse_background_color' ),
				'mobile_options'  	=> true,
				'tab_slug'          => 'advanced',
				'toggle_slug'       => 'hotspot',			
			),
			'enable_pulse_tablet' => array(
				'type' 		=> 'skip',
				'affects' 	=> array( 'pulse_background_color' ),
			),
			'enable_pulse_phone' => array(
				'type' 		=> 'skip',
				'affects' 	=> array( 'pulse_background_color' ),
			),
			'pulse_background_color'    => array(
				'label'           	=> esc_html__( 'Pulse Effect Color', 'dd_builder' ),
				'type'            	=> 'color-alpha',
				'default'			=> et_builder_accent_color(),
				'depends_show_if' 	=> 'on',
				'mobile_options'  	=> true,
				'sticky'          	=> true,
				'hover'				=> 'tabs',
				'tab_slug'        	=> 'advanced',
				'toggle_slug'     	=> 'hotspot',
			),
			'item_icon_color'     => array(
				'label'          	=> esc_html__( 'Icon Color', 'et_builder' ),
				'description'    	=> esc_html__( 'Here you can define a custom color for your icon.', 'et_builder' ),
				'type'           	=> 'color-alpha',
				'show_if'			=> array('item_content' => 'icon'),
				'hover'          	=> 'tabs',
				'mobile_options' 	=> true,
				'sticky'         	=> true,
				'tab_slug'       	=> 'advanced',
				'toggle_slug'    	=> 'icon',
			),
			'item_icon_width'     => array(
				'label'           	=> esc_html__( 'Icon Size', 'et_builder' ),
				'description'     	=> esc_html__( 'Here you can choose icon width.', 'et_builder' ),
				'default'         	=> '24px',
				'type'            	=> 'range',
				'mobile_options'	=> true,
				'default_unit'		=> 'px',
				'allowed_units'   	=> array( '%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw' ),
				'show_if'			=> array('item_content' => 'icon'),
				'mobile_options'  	=> true,
				'sticky'          	=> true,
				'hover'           	=> 'tabs',
				'tab_slug'        	=> 'advanced',
				'toggle_slug'     	=> 'icon'
			),
			'item_image_width' => array(
				'label'           	=> esc_html__( 'Image Width', 'et_builder' ),
				'type'            	=> 'range',
				'default'			=> '57px',
				'allowed_values' 	=> et_builder_get_acceptable_css_string_values( 'width' ),
				'default_unit'		=> 'px',
				'show_if'			=> array( 'item_content' => 'image' ),
				'mobile_options'  	=> true,
				'sticky'			=> true,
				'tab_slug'       	=> 'advanced',
				'toggle_slug'     	=> 'icon',
			),
			'tooltip_placement'              => array(
				'label'            => esc_html__( 'Placement', 'et_builder' ),
				'type'             => 'select',
				'options'          => $helper->get_positions(),
				'default' 		=> 'top',
				'show_if'		   => array( 'link_type' => 'tooltip'),				
				'mobile_options'   => true,
				'tab_slug'         => 'advanced',
				'toggle_slug'      => 'link',
			),
			'tooltip_width'            => array(
				'label'            	=> esc_html__( 'Width', 'et_builder' ),
				'type'            	=> 'range',
				'default'			=> '300px',
				'show_if'  			=> array('link_type' => 'tooltip'), 
				'tab_slug'         	=> 'advanced',
				'toggle_slug'       => 'link',
				'mobile_options'   	=> true,
				'validate_unit'    	=> true,
				'allowed_units'    	=> array( '%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw' ),
				'mobile_options'   	=> true,
				'sticky'           	=> true,
			),
			'tooltip_offset' => array(
				'label'         	=> esc_html__( 'Offset', 'et_builder' ),
				'type'         		=> 'range',
				'default'  			=> '15px',
				'show_if' 			=> array( 'link_type' => 'tooltip' ),
				'fixed_unit'		=> 'px',
				'mobile_options'	=> true,
				'tab_slug'          => 'advanced',
				'toggle_slug'   	=> 'link',
			),
			'tooltip_background_color' => array(
				'label'             => esc_html__( 'Background Color', 'et_builder' ),
				'type'              => 'color-alpha',
				'default' 			=> '#ffffff',
				'sticky'			=> true,
				'show_if'			=> array( 'link_type' => 'tooltip' ),
				'tab_slug'          => 'advanced',
				'toggle_slug'       => 'link',
			),	
			'arrow_color' => array(
				'label'             => esc_html__( 'Arrow Color', 'dd_builder' ),
				'type'              => 'color-alpha',
				'default' 			=> '#ffffff',
				'sticky'			=> true,
				'show_if'			=> array( 'link_type' => 'tooltip', 'tooltip_arrow' => 'on' ),
				'tab_slug'          => 'advanced',
				'toggle_slug'       => 'link',
			),		
        );
		$fields['module_class'] = $helper->get_custom_class_field();
		$fields['item_alt'] 	= $helper->get_alt_field( array( 'item_content' => 'image' ), 'Image Alt Text' );
	
		$cc_settings = array(
			'content_slug' 	=> 'content',
			'link_slug'		=> 'link_options',
			'advanced_slug'	=> 'content',
			'icon'			=> true,
			'icon_slug'		=> 'link_icon',
			'button'		=> true,
			'show_if_not' 	=> array('link_type' => array('none', 'url', 'popup_l')),
		);

		$popup_settings = array(
			'preview' => true,
			'show_if' => array('link_type' => 'popup_l'),
			'show_if_custom' => array('link_type' => array('popup_c', 'popup_l')),
			'toggle_slug' => 'content',
			'advanced_slug' => 'link'
		);

        $fields = array_merge(
			$fields,
			$helper->get_font_fields( 'body_ul', 'body_ol', 'body_quote', 'body'),
			$helper->get_url_fields( 'content', 'url', array( 'bookmark', 'external', 'nofollow', 'noreferrer', 'noopener', 'sponsored' )),
			$helper->get_popup_fields($popup_settings),
			$helper->get_custom_content_fields($cc_settings),
			$helper->get_effect_fields('effects', array('link_type' => array( 'tooltip', 'popup_c', 'popup_l' ) ) )
		);
        return $fields;
    }

	public function get_transition_fields_css_props() {
		$fields 	= parent::get_transition_fields_css_props();
		$selector 	= ".{$this->get_module_order_class( $this->slug )}_tab"; 
		
		$fields['item_icon_color'] = array(
			'color' => '%%order_class%% .ddb-hotspot > .ddb-icon',
		);

		return $fields;
	}
 
    public function render( $attrs, $content, $render_slug ) {
		$popup 		= '';
		$has_popup 	= in_array($this->props['link_type'], array( 'popup_c', 'popup_l' ) );
		$helper 	= DonDiviBuilderHelper::get();
		$multi_view	= et_pb_multi_view_options( $this );
		
		if ( $has_popup ) {
			wp_enqueue_script( 'ddb-popup' );
			$popup = $helper->render_popup( array(
				'module' => $this,
				'slug'	=> 'hotspot',
				'layout_popup' => $this->props['link_type'] === 'popup_l',
				'attrs' => array( 'data-element-class' => $this->get_module_order_class( $render_slug ) . ' .ddb-hotspot' ),
			));
		}

        $this->generate_styles(
			array(
				'base_attr_name' => 'hotspot_top',
				'selector'       => '%%order_class%%',
				'css_property'   => 'top',
				'render_slug'    => $render_slug,
			)
		);
        $this->generate_styles(
			array(
				'base_attr_name' => 'hotspot_left',
				'selector'       => '%%order_class%%',
				'css_property'   => 'left',
				'render_slug'    => $render_slug,
			)
		);
		$this->generate_styles(
			array(
				'base_attr_name' => 'hotspot_background_color',
				'selector'       => '%%order_class%% .ddb-hotspot, %%order_class%% .ddb-pulse',
				'hover_selector' => '%%order_class%% .ddb-hotspot:hover, %%order_class%% .ddb-hotspot.active',
				'css_property'   => 'background-color',
				'render_slug'    => $render_slug,
			)
		);

		$pulse = '';
		if ( $multi_view->has_value( 'enable_pulse', 'on' ) ) { 
			$pulse = $multi_view->render_element(
				array(
					'tag'        => '<div>',
					'attrs'      => array(
						'class' => 'ddb-pulse ddb-abs ddb-tl ddb-100',
					),
					'visibility' => array(
						'enable_pulse' => 'on',
					),
				)
			);
			$this->generate_styles(
				array(
					'base_attr_name' 	=> 'pulse_background_color',
					'selector'       	=> '%%order_class%%.dondivi_hotspot .ddb-pulse',
					'css_property'   	=> 'background-color',
					'render_slug'    	=> $render_slug,
				)
			);	
		}

		$hotspot = '';
		if ( $this->props['item_content'] === 'text' ) {
			$hotspot = $helper->render_text( array(
				'module' 		=> $this, 
				'text_attr' 	=> 'title',
				'attrs'			=> array('class' => 'ddb-hotspot-text'),
				'custom'		=> true
			) );
	  	} else if ( $this->props['item_content'] === 'image' ) {
			$hotspot = $helper->render_image( array( 
				'module' 	=> $this, 
				'img_attr' 	=> 'item_image',
				'alt_attr'	=> 'item_alt',
				'attrs' 	=> array( 'class' => 'ddb-block'),
				'custom'	=> true,  
			) );
			$this->generate_styles(
				array(
					'base_attr_name'  	=> 'item_image_width',
					'selector'      	=> '%%order_class%% .ddb-hotspot > img',
					'css_property'   	=> 'width',
					'render_slug' 		=> $render_slug,
				)
			);
	  	} else if ( $this->props['item_content'] !== 'none' ) {
			$hotspot = $helper->render_icon( array( 
				'module' => $this, 
				'icon_attr' => 'item_font_icon', 
				'color_attr' => 'item_icon_color',
				'size_attr' => 'item_icon_width',
				'selector' =>  '%%order_class%% .ddb-hotspot > .ddb-icon', 
				'hover_selector' => '%%order_class%%.hover .ddb-hotspot > .ddb-icon, %%order_class%% .ddb-hotspot:hover > .ddb-icon, %%order_class%% .ddb-hotspot.active > .ddb-icon', 
				'content_hover' => '%%order_class%% .ddb-hotspot > .ddb-icon.hover, %%order_class%% .ddb-hotspot > .ddb-icon.active',
				'attrs' => array( 'class' => 'ddb-block' ),
				'custom' => true,
			));
		} 
		
		$item_attrs = array('class' => 'ddb-hotspot ddb-rel ddb-btn ddb-light ddb-bss ddb-p-s');
		$item_tag = 'div';
		if ( $this->props['link_type'] === 'url') {
			$item_attrs['class'] .= ' ddb-block';
			$item_attrs['href'] = apply_filters( 'dondivi_hotspot_url', $this->get_url(), $this->props );
			$item_attrs['rel'] = $this->get_rel_attributes( $this->props['link_rel'], false );
			$item_tag = 'a';
			if ( $this->props['url_new_window'] === 'on' ) $item_attrs['target']= '_blank'; 		
		} else if ($this->props['link_type'] === 'tooltip') {
			$item_attrs['class'] .= ' ddb-tooltip-hotspot';
			if ($this->props['tooltip_hover'] !== 'off') $item_attrs['class'] .= ' ddb-show-hover';
		}
		$hotspot_item = $multi_view->render_element(
			array(
				'tag'       => $item_tag,
				'content'	=> $hotspot,
				'attrs'		=> $item_attrs,
			)
		);
        return $pulse . $hotspot_item . $this->render_tooltip() . $popup;
    }

	public function multi_view_filter_value( $raw_value, $args ) {

		$name = isset( $args['name'] ) ? $args['name'] : '';

		if ( $raw_value && ( 'item_font_icon' === $name || 'popup_close_font_icon' === $name || 'cc_icon' === $name ) ) {
			return et_pb_get_extended_font_icon_value( $raw_value, true );
		}
		return $raw_value;
	}

	private function get_opposite($placement) {
		switch ($placement) {
			case 'right': return  'left';
			case 'bottom': return 'top';
			case 'left': return 'right';
			default: return 'bottom';
		}
	}
	  
	private function get_tooltip_arrow_css($placement, $color) {
		switch ($placement) {
			case 'right': return sprintf( 'border-left:0;border-right-width:15px;border-right-color:%1$s;%2$s', $color, $this->get_tooltip_container_css('left') );
			case 'bottom': return sprintf( 'border-top:0;border-bottom-width:15px;border-bottom-color:%1$s;%2$s', $color, $this->get_tooltip_container_css('top') );
			case 'left': return sprintf( 'border-right:0;border-left-width:15px;border-left-color:%1$s;%2$s', $color, $this->get_tooltip_container_css('right') );
			default: return sprintf( 'border-bottom:0;border-top-width:15px;border-top-color:%1$s;%2$s', $color, $this->get_tooltip_container_css('bottom') );
		}
	}

    private function get_tooltip_container_css($placement, $margin = null) {
		$top = $right = $bottom = $left = 'auto';
		$transform = $margin_css = '';
		$translateX = 'transform:translateX(-50%);';
		$translateY = 'transform:translateY(-50%);'; 
		if ($placement === 'right') {
			$top = '50%'; $left = '100%'; $transform = $translateY;
		} else if ( $placement === 'bottom' ) {
			$top = '100%'; $left= '50%'; $transform = $translateX;
		} else if ( $placement === 'left') {
			$top = '50%'; $right = '100%'; $transform = $translateY;
		} else { 
			$bottom = '100%'; $left= '50%'; $transform = $translateX;
		}
		if ($margin) { 
			$margin_css = sprintf('margin-%1$s:%2$s;', $this->get_opposite($placement), $margin);
		}
		return sprintf('top:%1$s;right:%2$s;bottom:%3$s;left:%4$s;%5$s%6$s',
			$top, $right, $bottom, $left, $margin_css, $transform
		);
	}

	public function get_url()  {
		$url = '#'; 
		if ( !empty($this->props['url']) )
			$url = esc_url($this->props['url']);
		return $url;
	}

	private function render_tooltip() {		
		$tooltip = '';
		if ($this->props['link_type'] === 'tooltip') {
			$helper 	= DonDiviBuilderHelper::get();
			$multi_view	= et_pb_multi_view_options( $this );
			$offset 	= et_pb_responsive_options()-> get_property_values($this->props, 'tooltip_offset', $this->props['tooltip_offset'], true);
			$placement 	= et_pb_responsive_options()-> get_property_values($this->props, 'tooltip_placement', $this->props['tooltip_placement'], true);
			
			$content_attrs = array( 'class' => 'ddb-custom-hotspot ddb-f ddb-p-m ddb-bss' );
			$helper->set_effect_attrs( $content_attrs, $this->props );

			if ($this->props['tooltip_arrow'] === 'on') {
				$content_attrs['class'] .= ' ddb-arrow';
				foreach ( et_pb_responsive_options()->get_modes() as $device ) {
					$helper->set_style( 
						$this->slug, 
						'%%order_class%% .ddb-arrow:after', 
						$this->get_tooltip_arrow_css($placement[$device], $this->props['arrow_color']),
						substr( $device, 0, 1 ) 
					);
				}
			}
			$custom_content = $multi_view->render_element(
				array(
					'tag'       => 'div',
					'content'	=> $helper->render_custom_content( $this, array( 'slug' => 'hotspot' ) ),
					'attrs'		=> $content_attrs,
				)
			);
			$tooltip = $multi_view->render_element(
				array(
					'tag'       => 'div',
					'content'	=> $custom_content,
					'attrs'		=> array( 'class' => 'ddb-tooltip ddb-abs ddb-none' ),
				)
			);

			foreach ( et_pb_responsive_options()->get_modes() as $device ) {
				$helper->set_style( 
					$this->slug, 
					'%%order_class%% .ddb-tooltip', 
					$this->get_tooltip_container_css($placement[$device], $offset[$device]),
					substr( $device, 0, 1 ) 
				);
			}
			$this->generate_styles(
				array(
					'base_attr_name' 	=> 'tooltip_width',
					'selector'       	=> '%%order_class%% .ddb-tooltip',
					'css_property'   	=> 'width',
					'render_slug'    	=> $this->slug,
				)
			);
			$this->generate_styles(
				array(
					'base_attr_name' 	=> 'tooltip_background_color',
					'selector'       	=> '%%order_class%% .ddb-custom-hotspot',
					'css_property'   	=> 'background-color',
					'render_slug'    	=> $this->slug,
				)
			);
		}
		return $tooltip;
	}
}

new DDBUILDER_Hotspot_Item_Module;