<?php

class DDBUILDER_Timeline_Item_Module extends ET_Builder_Module {

	public $slug       = 'dondivi_timeline_item';
	public $vb_support = 'on';
	

	public function init() {
		$this->name = esc_html__( 'Event', 'et_builder' );
		$this->type = 'child';
		$this->child_title_var	= 'title';
		$this->child_title_fallback_var	= 'admin_title';

		$this->main_css_element	= '%%order_class%%';
		
		$this->settings_modal_toggles = array(
            'general'    => array(
                'toggles' => array(
                    'main_content' 	=>  esc_html__( 'Timeline', 'dd_builder' ),
					'card' 			=>  esc_html__( 'Card', 'et_builder' ),
                ),
            ),
			'advanced'    => array(
                'toggles' => array(
					'label' 	=> esc_html__( 'Label', 'et_builder' ),
					'line_text' 	=> sprintf( '%1$s %2$s', esc_html__( 'Marker', 'dd_builder' ), et_builder_i18n( 'Text' ) ),
					'icon' 			=> sprintf( '%1$s %2$s', esc_html__( 'Marker', 'dd_builder' ), esc_html__( 'Image & Icon', 'et_builder' ) ),
					'card' 			=> esc_html__( 'Card', 'et_builder' ),
					'card_icon' 	=> sprintf( '%1$s %2$s', esc_html__( 'Card', 'et_builder' ), esc_html__( 'Image & Icon', 'et_builder' ) ),
					'title' 		=> sprintf( '%1$s %2$s', esc_html__( 'Card', 'et_builder' ), et_builder_i18n( 'Title' ) ),
					'body'   		=> array(
						'title'             => sprintf( '%1$s %2$s', esc_html__( 'Card', 'et_builder' ), et_builder_i18n( 'Body' ) ),
						'tabbed_subtoggles' => true,
						'bb_icons_support'  => true,
						'sub_toggles'       => array(
							'p'     => array(
								'name' => 'P',
								'icon' => 'text-left',
							),
							'a'     => array(
								'name' => 'A',
								'icon' => 'text-link',
							),
							'ul'    => array(
								'name' => 'UL',
								'icon' => 'list',
							),
							'ol'    => array(
								'name' => 'OL',
								'icon' => 'numbered-list',
							),
							'quote' => array(
								'name' => 'QUOTE',
								'icon' => 'text-quote',
							),
						),
					),
					'card_button' 	=> sprintf( '%1$s %2$s', esc_html__( 'Card', 'et_builder' ), esc_html__( 'Button', 'et_builder' ) ),
					'effects' 		=> sprintf( '%1$s %2$s', esc_html__( 'Card', 'et_builder' ), esc_html__( 'Animation', 'et_builder' ) ),
                ),
            ),
        );

		$this->advanced_fields = array(
			'background'  	=> array(
				'css'     => array(
					'main' => '%%order_class%% .ddb-timeline-event .ddb-card-content',
				),
				'settings' => array(
					'tab_slug' => 'advanced',
					'toggle_slug'  => 'card',
				),
			),
			'box_shadow' 	=> false,
			'button'        => array(
				'button' => array(
					'label'          => et_builder_i18n( 'Button' ),
					'css'            => array(
						'main'         => "{$this->main_css_element} .ddb-card .ddb-timeline-item-button",
						'alignment'    => "{$this->main_css_element} .ddb-card .et_pb_button_module_wrapper",
					),
					'use_alignment'  => true,
					'box_shadow'     => array(
						'css' => array(
							'main' => '%%order_class%% .ddb-timeline-item-button',
						),
					),
					'toggle_slug' 	=> 'card_button', 
				),
			),
			'fonts'          => array(
				'label' => array(
					'label'        => esc_html__( 'Label', 'et_builder' ),
					'css'          => array(
						'main'  => "{$this->main_css_element} .ddb-label-item",
					),
					'hide_text_align'	=> true,
					'toggle_slug' 		=> 'label',
				),
				'line' => array(
					'label'        => esc_html__( 'Marker', 'dd_builder' ),
					'css'          => array(
						'main'  => "{$this->main_css_element} .ddb-line-text",
					),
					'text_shadow' 		=> array( 'show_if' => array( 'line_content' => 'text' ) ),
					'depends_show_if' 	=> 'text',
					'toggle_slug' 		=> 'line_text',
				),
				'title' => array(
					'label'        => et_builder_i18n( 'Title' ),
					'css'          => array(
						'main'  => "{$this->main_css_element} .ddb-timeline-item-title",
					),
					'header_level' => array(
						'default' => 'h4',
					),
					'toggle_slug' => 'card_text',
					'sub_toggle'  => 'title',
				),
				'body'   => array(
					'label'          => et_builder_i18n( 'Body' ),
					'css'            => array(
						'main' => "{$this->main_css_element} .ddb-timeline-item-body",
					),
					'block_elements' => array(
						//'tabbed_subtoggles' => true,
						//'bb_icons_support'  => true,
						'css'               => array(
							'link'           => "{$this->main_css_element} .ddb-timeline-item-body a",
							'ul'             => "{$this->main_css_element} .ddb-timeline-item-body ul li",
							'ul_item_indent' => "{$this->main_css_element} .ddb-timeline-item-body ul",
							'ol'             => "{$this->main_css_element} .ddb-timeline-item-body ol li",
							'ol_item_indent' => "{$this->main_css_element} .ddb-timeline-item-body ol",
							'quote'          => "{$this->main_css_element} .ddb-timeline-item-body blockquote",
						),
					),	
				),
			),
			'image_icon'     => array(
				'image_icon' => array(
					'label'           	=> et_builder_i18n( 'Image/Icon' ),
					'css'             	=> array(
						'main'    => '%%order_class%% .ddb-timeline-item-image-icon',
					),
					'toggle_slug'     	=> 'card_icon',
				),
			),
			'max_width'   		=> false,
			'margin_padding' 	=> array(
				'css' => array(
					'padding'   => "{$this->main_css_element} .ddb-card-content",
					'important' => 'all',
				),
				'use_margin' 	=> false,
				'toggle_slug' 	=> 'card',
			),
			'position_fields' 	=> false,	
			'text'           	=> array(
				'css'                   => array(
					'text_shadow' => "{$this->main_css_element} .ddb-card-content",
				),
				'toggle_slug' => 'card',
			),
			'text_shadow'      => array(
				'default' => false,
			),
		);

		$this->custom_css_fields = array(
			'label_css' => array(
				'label'    => esc_html__( 'Label', 'et_builder' ),
				'selector' => '%%order_class%% .ddb-label-item',
			),
			'marker_css' => array(
				'label'    => esc_html__( 'Marker', 'et_builder' ),
				'selector' => '%%order_class%% .ddb-event-item',
			),
			'card' => array(
				'label'    => esc_html__( 'Card', 'et_builder' ),
				'selector' => '%%order_class%% .ddb-card-content',
			),
			'card_image_icon_css' => array(
				'label'    	=>  sprintf( '%1$s %2$s', esc_html__( 'Card', 'et_builder' ), esc_html__( 'Image & Icon', 'et_builder' ) ),
				'selector' 	=> '%%order_class%% .ddb-card-content .ddb-timeline-item-image-icon',
				'show_if'  	=> array( 'cc_icon_image' => array( 'icon', 'image' )),
			),
			'card_title_css' => array(
				'label'    	=>  sprintf( '%1$s %2$s', esc_html__( 'Card', 'et_builder' ), et_builder_i18n( 'Title' ) ),
				'selector' 	=> '%%order_class%% .ddb-card-content .ddb-timeline-item-title',
			),
			'card_body_css' => array(
				'label'    	=>  sprintf( '%1$s %2$s', esc_html__( 'Card', 'et_builder' ), et_builder_i18n( 'Body' ) ),
				'selector' 	=> '%%order_class%% .ddb-card-content .ddb-timeline-item-body',
			),
		);
	}
	
	public function get_fields() {
		$helper = new DonDiviBuilderFields();
		$fields = array(
			'title'			=> array(
				'label'           	=> et_builder_i18n( 'Label' ),
				'type'            	=> 'text',
				'dynamic_content' 	=> 'text',
				'mobile_options'  	=> true,
				'hover'           	=> 'tabs',
				'toggle_slug'     	=> 'main_content',
			),
			'line_content' 	=> array(
				'label'        	=> esc_html__( 'Marker', 'dd_builder' ),
				'type'         	=> 'select',
				'options'       => array(
					'none' 		=> et_builder_i18n( 'None' ),
					'text' 		=> et_builder_i18n( 'Text' ),
					'icon'  	=> esc_html__( 'Icon', 'et_builder' ),
					'image'  	=> et_builder_i18n( 'Image' ),
				),
				'default'		=> 'none',
				'affects' 		=> array( 'line_font', 'line_font_size', 'line_letter_spacing', 'line_text_color', 'line_line_height', 'line_text_align' ),
				'toggle_slug'   => 'main_content',
			),
			'line_text'	=> array(
				'label'           	=> et_builder_i18n( 'Text' ),
				'type'            	=> 'text',
				'show_if'			=> array('line_content' => 'text'),
				'dynamic_content' 	=> 'text',
				'mobile_options'  	=> true,
				'hover'           	=> 'tabs',
				'toggle_slug'     	=> 'main_content',
			),
			'line_font_icon' => array(
				'label'             => esc_html__( 'Icon', 'et_builder' ),
				'type'              => 'select_icon',
				'class'             => array( 'et-pb-font-icon' ),
				'show_if'			=> array( 'line_content' => 'icon'),
				'hover'				=> 'tabs',
				'toggle_slug'       => 'main_content',			
			),
			'line_image' => array(
				'label'             => esc_html__( 'Image', 'et_builder' ),
				'type'              => 'upload',
				'upload_button_text'=> esc_attr__( 'Upload an image', 'et_builder' ),
				'choose_text'       => esc_attr__( 'Choose an Image', 'et_builder' ),
				'update_text'       => esc_attr__( 'Set As Image', 'et_builder' ),
				'show_if'			=> array('line_content' => 'image'),
				'mobile_options'  	=> true,
				'hover'				=> 'tabs',
				'dynamic_content'   => 'image',
				'toggle_slug'       => 'main_content',
			),
			'admin_title'          => array(
				'label'       		=> et_builder_i18n( 'Admin Label' ),
				'type'        		=> 'text',
				'default'			=> esc_html__( 'Label', 'et_builder' ),
				'toggle_slug' 		=> 'admin_label',
			),
			'line_icon_color'     => array(
				'label'          	=> esc_html__( 'Icon Color', 'et_builder' ),
				'description'    	=> esc_html__( 'Here you can define a custom color for your icon.', 'et_builder' ),
				'type'           	=> 'color-alpha',
				'show_if'			=> array('line_content' => 'icon'),
				'hover'          	=> 'tabs',
				'mobile_options' 	=> true,
				'sticky'         	=> true,
				'tab_slug'       	=> 'advanced',
				'toggle_slug'    	=> 'icon',
			),
			'line_icon_width'     => array(
				'label'           	=> esc_html__( 'Icon Size', 'et_builder' ),
				'description'     	=> esc_html__( 'Here you can choose icon width.', 'et_builder' ),
				'default'         	=> '24px',
				'type'            	=> 'range',
				'default_unit'		=> 'px',
				'allowed_units'   	=> array( '%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw' ),
				'show_if'			=> array('line_content' => 'icon'),
				'mobile_options'  	=> true,
				'sticky'          	=> true,
				'hover'           	=> 'tabs',
				'tab_slug'        	=> 'advanced',
				'toggle_slug'     	=> 'icon'
			),
			'line_image_width' => array(
				'label'           	=> esc_html__( 'Image Width', 'et_builder' ),
				'type'            	=> 'range',
				'range_settings' 	=> array(
					'max'  	=> 200,
					'step'	=> 1
				),
				'default'			=> '57px',
				'allowed_values' 	=> et_builder_get_acceptable_css_string_values( 'width' ),
				'default_unit'		=> 'px',
				'validate_unit'		=> true,			
				'show_if'			=> array('line_content' => 'image'),
				'mobile_options'  	=> true,
				'sticky'			=> true,
				'tab_slug'       	=> 'advanced',
				'toggle_slug'     	=> 'icon',
			),
			'arrow_color' => array(
				'label'             	=> esc_html__( 'Arrow Color', 'dd_builder' ),
				'type'              	=> 'color-alpha',
				'sticky'				=> true,
				'mobile_options'   		=> true,
				'tab_slug'          	=> 'advanced',
				'toggle_slug'       	=> 'card',
			),
		);
		$card_settings = array(
			'content_slug' 	=> 'card',
			'link_slug'		=> 'link_options',
			'advanced_slug'	=> 'card_text',
			'icon'			=> true,
			'advanced_slug'	=> 'card_icon',
			'button'		=> true,
		);
		$fields['module_class'] = $helper->get_custom_class_field();
		$fields['line_alt'] 	= $helper->get_alt_field( array('line_content' => 'image'), 'Image Alt Text' ); 
		return array_merge( 
			$helper->get_effect_fields( 'effects', false, 'none', 'none', '1000ms', true ),
			$helper->get_effect_fields( 'card_icon', array( 'cc_icon_image' => array( 'icon', 'image')), 'none', 'none', '1000ms', true, 'card' ),
			$fields,
			$helper->get_custom_content_fields( $card_settings )
		);
	}

	public function multi_view_filter_value( $raw_value, $args ) {

		$name = isset( $args['name'] ) ? $args['name'] : '';

		if ( $raw_value && ( 'line_font_icon' === $name || 'cc_icon' === $name ) ) {
			return et_pb_get_extended_font_icon_value( $raw_value, true );
		}

		return $raw_value;
	}

	public function render_label( $helper, $multi_view, $label_classnames ) {
		$label = $multi_view->render_element(
			array(
				'tag' 		=> 'div',
				'content'	=> $helper->render_text( array( 'module' => $this, 'text_attr' => 'title' ) ),
				'attrs'		=> array( 'class' => $label_classnames ),
				'visibility'=> array( 'title' => '__not_empty' )
			)
		);
		return sprintf( '<div class="ddb-event-label">%s</div>', $label );
	}

	public function render( $attrs, $content, $render_slug ) {

		$helper 	= DonDiviBuilderHelper::get();
		$multi_view	= et_pb_multi_view_options( $this );

		$line_item = '';
		if ($this->props['line_content'] === 'text') {
			$line_item = $multi_view->render_element(
				array(
					'content'	=> '{{line_text}}',
					'attrs'	=> array('class' => 'ddb-line-text'),
				)
			);
			$line_item = sprintf( '<div class="ddb-line-item ddb-light ddb-f ddb-f-c">%s</div>', $line_item ); 
		} else if ($this->props['line_content'] === 'icon')
			$line_item = $helper->render_icon( array( 
				'module' => $this, 
				'icon_attr' => 'line_font_icon', 
				'color_attr' => 'line_icon_color', 
				'size_attr' => 'line_icon_width', 
				'selector' =>  '%%order_class%% .ddb-event-item > .ddb-icon', 
				'attrs' => array( 'class' => 'ddb-block ddb-light' )
			) );
	    else if ($this->props['line_content'] === 'image') {
			$line_item = $helper->render_image( array( 
				'module' => $this, 
				'alt_attr' => 'line_alt',
				'img_attr' => 'line_image',
				'attrs' => array( 'class' => 'ddb-block' )
			) );
			$this->generate_styles(
				array(
					'base_attr_name' => 'line_image_width',
					'selector'       => '%%order_class%% .ddb-event-item > img',
					'css_property'   => 'width',
					'render_slug'    => $render_slug,
				)
			);
		}

		$timeline_item = $multi_view->render_element(
			array(
				'tag' => 'div',
				'content' => $line_item,
				'attrs' => array('class' => 'ddb-event-item ddb-p-m ddb-bss'),
			)
		);

		$timeline_content = $multi_view->render_element(
			array(
				'tag' => 'div',
				'content' => $timeline_item,
				'attrs' => array('class' => 'ddb-event-line ddb-f ddb-f-cc'),
			)
		);

		$card_attrs = array( 'class' => 'ddb-card ddb-rel ddb-f' );
		$helper->set_effect_attrs( $card_attrs, $this->props, array( 'lazy_loading' => true ) );

		$custom_content = sprintf('<div class="ddb-card-content ddb-p-xl ddb-bss">%1$s<div class="ddb-custom-timeline-item ddb-f">%2$s</div></div>', 
			$this->render_label( $helper, $multi_view, 'ddb-label-item ddb-card-label ddb-mb ddb-none' ),
			$helper->render_custom_content( $this, array( 'slug' => 'timeline-item', 'waypoints' => true, 'effects_prefix' => 'card'  ) ) 
		);
		$card = $multi_view->render_element(
			array(
				'tag'     => 'div',
				'content' => $custom_content,
				'attrs'   => $card_attrs
			)
		);

		$this->add_classname( $this->get_text_orientation_classname() );
		$this->generate_styles(  
			array(
				'base_attr_name' 	=> 'arrow_color',
				'selector'     		=> '%%order_class%% .ddb-timeline-event .ddb-card:after',
				'css_property' 		=> '--ddb-arrow-color',
				'render_slug'      	=> $render_slug,
			)
		);
		
		return sprintf('<div class="ddb-timeline-event ddb-f ddb-f-c">%1$s%2$s%3$s</div>', 
			$this->render_label( $helper, $multi_view, 'ddb-label-item ddb-inline-block' ), 
			$timeline_content, 
			$card
		);
	}
}

new DDBUILDER_Timeline_Item_Module;